// $primary-color: #00671a;
// $secondary-color: #448AFF;

:root {
  // Polymer
  // --dark-primary-color: darken($primary-color, 10%);
  // --default-primary-color: $primary-color;
  // --light-primary-color: lighten($primary-color, 10%);
  --text-primary-color: #ffffff;
  --accent-color: #ff4081;
  --primary-background-color: #ffffff;
  --primary-text-color: #212121;
  --secondary-text-color: #757575;
  --disabled-text-color: #bdbdbd;
  --divider-color: #e0e0e0;
  --error-color: red;

  // Custom
  // --primary-color: $primary-color;
  // --secondary-color: $secondary-color;
  // @for $i from 1 through 6 {
  //   --primary-color-light-#{$i}0: lighten($primary-color, percentage($i/10));
  //   --primary-color-dark-#{$i}0: darken($primary-color, percentage($i/10));
  //
  //   --secondary-color-light-#{$i}0: lighten($secondary-color, percentage($i/10));
  //   --secondary-color-dark-#{$i}0: darken($secondary-color, percentage($i/10));
  // }
}

:unresolved:after {
  content: 'unknown element';
  border: 1px solid #F00;
  padding: 5px;
  background: #F7EAEA;
}
// firefox thinks ALL elements are unresolved
@-moz-document url-prefix() {
  :unresolved:after {
    content: "";
    border: none;
    padding: 0;
    background: none;
  }
}

h1, h2, h3, h4, h5, h6, span, p, div, paper-toast, paper-button, paper-tab, paper-radio-button, paper-item, paper-checkbox {
  font-family: 'Roboto', 'Noto', sans-serif;
  -webkit-font-smoothing: antialiased;
  text-rendering: optimizeLegibility;
  color: var(--text-color);
}

paper-button {
  --paper-button-ink-color: var(--primary-color);
  color: var(--text-color);
  --paper-button: {}
  --paper-button-disabled: {}
  --paper-button-flat-keyboard-focus: {}
  --paper-button-raised-keyboard-focus: {}

  min-height: 2em;
  padding: 0.4em 0.57em;

  iron-icon {
    height: 100%;
    top: -1px;
  }

  &[toggles] {
    &::before {
      content: "";
      transition: background-color 0.4s;
    }
    &[active]::before {
      background-color: var(--primary-color);
      width: 100%;
      height: 100%;
      position: absolute;
      top: 0;
      left: 0;
      opacity: .25;
      z-index: -1;
    }
  }

  &[raised] {
    background-color: white;
    &[primary] {
      color: white;
      background-color: var(--primary-color);
      /*--paper-button-ink-color: white;*/
    }
    &[secondary] {
      color: white;
      background-color: var(--secondary-color);
      /*--paper-button-ink-color: white;*/
    }
    &[info] {
      color: white;
      background-color: var(--paper-blue-500);
      /*--paper-button-ink-color: white;*/
    }
    &[warning] {
      color: white;
      background-color: var(--paper-orange-500);
      /*--paper-button-ink-color: white;*/
    }
    &[error] {
      color: white;
      background-color: var(--paper-red-500);
      /*--paper-button-ink-color: white;*/
    }
    &[disabled] {
      background-color: var(--paper-grey-300);
      color: var(--paper-grey-800);
    }
  }

  &[primary] {
    color: var(--primary-color);
    /*--paper-button-ink-color: white;*/
  }
  &[secondary] {
    color: var(--secondary-color);
    /*--paper-button-ink-color: white;*/
  }
  &[info] {
    color: var(--paper-blue-500);
    /*--paper-button-ink-color: white;*/
  }
  &[warning] {
    color: var(--paper-orange-500);
    /*--paper-button-ink-color: white;*/
  }
  &[error] {
    color: var(--paper-red-500);
    /*--paper-button-ink-color: white;*/
  }
  &[disabled] {
    background-color: var(--paper-grey-300);
    color: var(--paper-grey-800);
  }
}

paper-card {
  .card-content {
    padding: 5px;
  }
}

paper-checkbox {
  // --paper-checkbox-unchecked-background-color: var(--primary-color, transparent);
  --paper-checkbox-unchecked-color: var(--primary-color-dark-10, --primary-text-color);
  --paper-checkbox-unchecked-ink-color: var(--primary-color, --primary-text-color);
  --paper-checkbox-checked-color: var(--primary-color, --default-primary-color);
  --paper-checkbox-checked-ink-color: var(--primary-color, --default-primary-color);
  // --paper-checkbox-checkmark-color: var(--primary-color-light-20, white);
  --paper-checkbox-label-color: var(--text-color, --primary-text-color);
  // --paper-checkbox-error-color: var(--primary-color, --google-red-500);
}

paper-fab {
  --paper-fab-background: var(--primary-color, --accent-color);
  --paper-fab-keyboard-focus-background: var(--primary-color-dark-10, --paper-pink-900);
  // --paper-fab-disabled-background: var(--primary-color, --paper-grey-300);
  // --paper-fab-disabled-text: var(--primary-color, --paper-grey-500);
  --paper-fab: {}
  --paper-fab-mini: {}
  --paper-fab-disabled: {}

  &[primary] {
    color: white;
    --paper-fab-background: var(--primary-color, --accent-color);
  }
  &[secondary] {
    color: white;
    --paper-fab-background: var(--secondary-color, --accent-color);
  }
  &[info] {
    color: white;
    --paper-fab-background: var(--paper-blue-500, --accent-color);
  }
  &[warning] {
    color: white;
    --paper-fab-background: var(--paper-orange-500, --accent-color);
  }
  &[error] {
    color: white;
    --paper-fab-background: var(--paper-red-500, --accent-color);
  }
}

paper-icon-button {
  color: var(--primary-color, --primary-text-color);
  // --paper-icon-button-disabled-text: var(--primary-color-light-30, --primary-text-color);
  --paper-icon-button-ink-color: var(--primary-color, --default-primary-color);
  --paper-icon-button: {}
  --paper-icon-button-disabled: {}

  &[primary] {
    color: var(--primary-color, --primary-text-color);
  }
  &[secondary] {
    color: var(--secondary-color, --primary-text-color);
  }
  &[info] {
    color: var(--paper-blue-500, --primary-text-color);
  }
  &[warning] {
    color: var(--paper-orange-500, --primary-text-color);
  }
  &[error] {
    color: var(--paper-red-500, --primary-text-color);
  }
}

paper-material {
  background-color: white;
}

paper-input, paper-textarea {
  // --paper-input-container-color: var(--primary-color, --secondary-text-color);
  --paper-input-container-focus-color: var(--primary-color, --default-primary-color);
  // --paper-input-container-invalid-color: var(--primary-color, --google-red-500);
  --paper-input-container-input-color: var(--text-color, --primary-text-color);
  --paper-input-container: {}
  --paper-input-container-label: {}
  --paper-input-container-label-focus: {}
  --paper-input-container-input: {}
  --paper-input-container-input-disabled: {}
  --paper-input-container-prefix: {}
  --paper-input-container-suffix: {}
  --paper-input-container-underline: {}
  --paper-input-container-underline-focus: {}
  --paper-input-container-underline-disabled: {}
}

paper-item {
  // --paper-item-min-height: var(--primary-color, 48px);
  --paper-item: {}
}

paper-menu {
  // --paper-menu-background-color: var(transparent, --primary-background-color);
  --paper-menu-background-color: transparent;
  // --paper-menu-color: var(--primary-color, --primary-text-color);
  // --paper-menu-disabled-color: var(--primary-color, --disabled-text-color);
  --paper-menu: {}
  --paper-menu-selected-item: {}
  --paper-menu-focused-item: {}
  --paper-menu-focused-item-after: {}

  &[vertical][layout] {
    paper-item {
      display: block;
    }
  }
  paper-item {

  }

  paper-submenu {
    paper-item {
      font-weight: normal;
      &.iron-selected {
        font-weight: bold;
      }
    }
  }
}
paper-item {
  --paper-item-min-height: 2em;
  --paper-item-focused-before: #{'{
    background: none;
  }'};
  &:after {
    background: none !important;
  }
  &[aria-selected] {
    position: relative;
    &:before {
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      opacity: 0.2;
      // background: currentColor;
      background: var(--primary-color);
      content: '';
      pointer-events: none;
    }
  }
}

paper-progress {
  // --paper-progress-container-color: var(--primary-color-light-30, --google-grey-300);
  // --paper-progress-transition-duration: var(--primary-color, 0.008s);
  // --paper-progress-transition-timing-function: var(--primary-color, ease);
  // --paper-progress-transition-delay: var(--primary-color, 0s);
  --paper-progress-active-color: var(--primary-color, --google-green-500);
  --paper-progress-secondary-color: var(--primary-color-light-10, --google-green-100);
  // --paper-progress-disabled-active-color: var(--primary-color, --google-grey-500);
  // --paper-progress-disabled-secondary-color: var(--primary-color, --google-grey-300);
  // --paper-progress-height: var(--primary-color, 4px);
  width: 100%;
}

paper-radio-button {
  // --paper-radio-button-unchecked-background-color: var(--primary-color-light-20, transparent);
  --paper-radio-button-unchecked-color: var(--primary-color, --primary-text-color);
  --paper-radio-button-unchecked-ink-color: var(--primary-color, --primary-text-color);
  --paper-radio-button-checked-color: var(--primary-color-dark, --default-primary-color);
  --paper-radio-button-checked-ink-color: var(--primary-color, --default-primary-color);
  // --paper-radio-button-label-color: var(--primary-color, --primary-text-color);

  &[primary] {
    --paper-radio-button-unchecked-color: var(--primary-color, --primary-text-color);
    --paper-radio-button-unchecked-ink-color: var(--primary-color, --primary-text-color);
    --paper-radio-button-checked-color: var(--primary-color-dark-10, --default-primary-color);
    --paper-radio-button-checked-ink-color: var(--primary-color, --default-primary-color);
  }
  &[secondary] {
    --paper-radio-button-unchecked-color: var(--secondary-color, --primary-text-color);
    --paper-radio-button-unchecked-ink-color: var(--secondary-color, --primary-text-color);
    --paper-radio-button-checked-color: var(--secondary-color-dark-10, --default-primary-color);
    --paper-radio-button-checked-ink-color: var(--secondary-color, --default-primary-color);
  }
  &[info] {
    --paper-radio-button-unchecked-color: var(--paper-blue-500, --primary-text-color);
    --paper-radio-button-unchecked-ink-color: var(--paper-blue-500, --primary-text-color);
    --paper-radio-button-checked-color: var(--paper-blue-600, --default-primary-color);
    --paper-radio-button-checked-ink-color: var(--paper-blue-500, --default-primary-color);
  }
  &[warning] {
    --paper-radio-button-unchecked-color: var(--paper-orange-500, --primary-text-color);
    --paper-radio-button-unchecked-ink-color: var(--paper-orange-500, --primary-text-color);
    --paper-radio-button-checked-color: var(--paper-orange-600, --default-primary-color);
    --paper-radio-button-checked-ink-color: var(--paper-orange-500, --default-primary-color);
  }
  &[error] {
    --paper-radio-button-unchecked-color: var(--paper-red-500, --primary-text-color);
    --paper-radio-button-unchecked-ink-color: var(--paper-red-500, --primary-text-color);
    --paper-radio-button-checked-color: var(--paper-red-600, --default-primary-color);
    --paper-radio-button-checked-ink-color: var(--paper-red-500, --default-primary-color);
  }
}
paper-radio-group {
  paper-radio-button {
    padding: 0 !important;
  }
}

paper-slider {
  // --paper-slider-bar-color: var(--primary-color, transparent);
  --paper-slider-active-color: var(--primary-color, --google-blue-700);
  --paper-slider-secondary-color: var(--secondary-color, --google-blue-300);
  --paper-slider-knob-color: var(--primary-color, --google-blue-700);
  // --paper-slider-disabled-knob-color: var(--primary-color, --google-grey-500);
  --paper-slider-pin-color: var(--primary-color, --google-blue-700);
  --paper-slider-font-color: var(--text-color, #fff);
  // --paper-slider-disabled-active-color: var(--primary-color, --google-grey-500);
  // --paper-slider-disabled-secondary-color: var(--primary-color, --google-grey-300);
  // --paper-slider-knob-start-color: var(--primary-color, transparent);
  --paper-slider-knob-start-border-color: var(--primary-color, #c8c8c8);
  --paper-slider-pin-start-color: var(--primary-color, #c8c8c8);
  // --paper-slider-height: var(--primary-color, 2px);

  width: 100%;

  &[primary] {
    --paper-slider-active-color: var(--primary-color, --google-blue-700);
    --paper-slider-secondary-color: var(--primary-color-light-20, --google-blue-300);
    --paper-slider-knob-color: var(--primary-color, --google-blue-700);
    --paper-slider-pin-color: var(--primary-color, --google-blue-700);
    --paper-slider-knob-start-border-color: var(--primary-color, #c8c8c8);
    --paper-slider-pin-start-color: var(--primary-color, #c8c8c8);
  }
  &[secondary] {
    --paper-slider-active-color: var(--secondary-color, --google-blue-700);
    --paper-slider-secondary-color: var(--secondary-color-light-20, --google-blue-300);
    --paper-slider-knob-color: var(--secondary-color, --google-blue-700);
    --paper-slider-pin-color: var(--secondary-color, --google-blue-700);
    --paper-slider-knob-start-border-color: var(--secondary-color, #c8c8c8);
    --paper-slider-pin-start-color: var(--secondary-color, #c8c8c8);
  }
  &[info] {
    --paper-slider-active-color: var(--paper-blue-500, --google-blue-700);
    --paper-slider-secondary-color: var(--paper-blue-300, --google-blue-300);
    --paper-slider-knob-color: var(--paper-blue-500, --google-blue-700);
    --paper-slider-pin-color: var(--paper-blue-500, --google-blue-700);
    --paper-slider-knob-start-border-color: var(--paper-blue-500, #c8c8c8);
    --paper-slider-pin-start-color: var(--paper-blue-500, #c8c8c8);
  }
  &[warning] {
    --paper-slider-active-color: var(--paper-orange-500, --google-blue-700);
    --paper-slider-secondary-color: var(--paper-orange-300, --google-blue-300);
    --paper-slider-knob-color: var(--paper-orange-500, --google-blue-700);
    --paper-slider-pin-color: var(--paper-orange-500, --google-blue-700);
    --paper-slider-knob-start-border-color: var(--paper-orange-500, #c8c8c8);
    --paper-slider-pin-start-color: var(--paper-orange-500, #c8c8c8);
  }
  &[error] {
    --paper-slider-active-color: var(--paper-red-500, --google-blue-700);
    --paper-slider-secondary-color: var(--paper-red-300, --google-blue-300);
    --paper-slider-knob-color: var(--paper-red-500, --google-blue-700);
    --paper-slider-pin-color: var(--paper-red-500, --google-blue-700);
    --paper-slider-knob-start-border-color: var(--paper-red-500, #c8c8c8);
    --paper-slider-pin-start-color: var(--paper-red-500, #c8c8c8);
  }
}

paper-spinner {
  --paper-spinner-layer-1-color: var(--primary-color, --google-blue-500);
  --paper-spinner-layer-2-color: var(--secondary-color, --google-red-500);
  --paper-spinner-layer-3-color: var(--accent-color, --google-yellow-500);
  --paper-spinner-layer-4-color: var(--secondary-text-color, --google-green-500);
}

paper-tabs {
  --paper-tabs-selection-bar-color: var(--primary-color-light-10, --paper-blue-a100);
  --paper-tabs:	{};
  height: 2.5em;
}
paper-tab {
  --paper-tab-ink: var(--primary-color-light-10, --paper-blue-a100);
  --paper-tab: {}
  --paper-tab-content: {}
}

paper-toast {
  z-index: 10000;
}

paper-toggle-button {
  --paper-toggle-button-unchecked-bar-color: var(--paper-grey-400, #000000);
  --paper-toggle-button-unchecked-button-color: var(--primary-color, --paper-grey-50);
  --paper-toggle-button-unchecked-ink-color: var(--primary-color,	--dark-primary-color);
  --paper-toggle-button-checked-bar-color: var(--primary-color,	--default-primary-color);
  --paper-toggle-button-checked-button-color: var(--primary-color, --default-primary-color);
  --paper-toggle-button-checked-ink-color: var(--primary-color,	--default-primary-color);
  --paper-toggle-button-unchecked-bar: {}
  --paper-toggle-button-unchecked-button: {}
  --paper-toggle-button-checked-bar: {}
  --paper-toggle-button-checked-button: {}
  &[disabled] {
    --paper-toggle-button-unchecked-button-color: var(--paper-grey-400);
    --paper-toggle-button-checked-button-color: var(--paper-grey-400);
  }
  &[primary] {
    --paper-toggle-button-unchecked-bar-color: var(--paper-grey-400, #000000);
    --paper-toggle-button-unchecked-button-color: var(--primary-color, --paper-grey-50);
    --paper-toggle-button-unchecked-ink-color: var(--primary-color,	--dark-primary-color);
    --paper-toggle-button-checked-bar-color: var(--primary-color,	--default-primary-color);
    --paper-toggle-button-checked-button-color: var(--primary-color, --default-primary-color);
    --paper-toggle-button-checked-ink-color: var(--primary-color,	--default-primary-color);
  }
  &[secondary] {
    --paper-toggle-button-unchecked-bar-color: var(--paper-grey-400, #000000);
    --paper-toggle-button-unchecked-button-color: var(--secondary-color, --paper-grey-50);
    --paper-toggle-button-unchecked-ink-color: var(--secondary-color,	--dark-primary-color);
    --paper-toggle-button-checked-bar-color: var(--secondary-color,	--default-primary-color);
    --paper-toggle-button-checked-button-color: var(--secondary-color, --default-primary-color);
    --paper-toggle-button-checked-ink-color: var(--secondary-color,	--default-primary-color);
  }
  &[info] {
    --paper-toggle-button-unchecked-bar-color: var(--paper-grey-400, #000000);
    --paper-toggle-button-unchecked-button-color: var(--paper-blue-500, --paper-grey-50);
    --paper-toggle-button-unchecked-ink-color: var(--paper-blue-500,	--dark-primary-color);
    --paper-toggle-button-checked-bar-color: var(--paper-blue-500,	--default-primary-color);
    --paper-toggle-button-checked-button-color: var(--paper-blue-500, --default-primary-color);
    --paper-toggle-button-checked-ink-color: var(--paper-blue-500,	--default-primary-color);
  }
  &[warning] {
    --paper-toggle-button-unchecked-bar-color: var(--paper-grey-400, #000000);
    --paper-toggle-button-unchecked-button-color: var(--paper-orange-500, --paper-grey-50);
    --paper-toggle-button-unchecked-ink-color: var(--paper-orange-500,	--dark-primary-color);
    --paper-toggle-button-checked-bar-color: var(--paper-orange-500,	--default-primary-color);
    --paper-toggle-button-checked-button-color: var(--paper-orange-500, --default-primary-color);
    --paper-toggle-button-checked-ink-color: var(--paper-orange-500,	--default-primary-color);
  }
  &[error] {
    --paper-toggle-button-unchecked-bar-color: var(--paper-grey-400, #000000);
    --paper-toggle-button-unchecked-button-color: var(--paper-red-500, --paper-grey-50);
    --paper-toggle-button-unchecked-ink-color: var(--paper-red-500,	--dark-primary-color);
    --paper-toggle-button-checked-bar-color: var(--paper-red-500,	--default-primary-color);
    --paper-toggle-button-checked-button-color: var(--paper-red-500, --default-primary-color);
    --paper-toggle-button-checked-ink-color: var(--paper-red-500,	--default-primary-color);
  }
}
[toggle-button-holder] {
  margin-bottom: 10px;
  span {
    margin-left: 10px;
    margin-right: 10px;
  }
}

paper-toolbar {
  --paper-toolbar-background: var(--primary-color, --default-primary-color);
  --paper-toolbar-color: var(--text-color, --text-primary-color);
  --paper-toolbar: {}
  paper-icon-button {
      color: white;
  }
}

[fullbleed] {
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
}

paper-ripple {
  color: var(--primary-color);
}

paper-dropdown-menu {
  --paper-dropdown-menu-ripple: #{'{
    color: var(--primary-color);
  }'};
}

vaadin-grid {
  --vaadin-grid-row-height: 3em;
  --vaadin-grid-header-row-height: 4em;
  --vaadin-grid-footer-row-height: 4em;
}
